stages:
  - Tag
  - Build and Upload

Tag:
  stage: Tag
  image: "quay.io/pantheon-public/autotag:v1.3.8"
  needs: []
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: '$CI_COMMIT_BRANCH == "master"'
      when: always
  variables:
    GIT_STRATEGY: fetch
    GIT_DEPTH: 0
  before_script:
    - |
      git fetch --tags
      if [ $(git rev-parse --abbrev-ref HEAD) != $CI_COMMIT_BRANCH ]; then
        git branch --track $CI_COMMIT_BRANCH origin/$CI_COMMIT_BRANCH
      fi
    - apk add curl
  script:
    - |
      if TAG=$(/autotag -n -b $CI_COMMIT_BRANCH --scheme=conventional); then
        echo "";
      else
        TAG=0.0.1;
      fi
    - |
      curl \
        --request POST \
        --header "PRIVATE-TOKEN: $TAGS_API_TOKEN" \
        --header "Content-Type: application/json" \
        -d "{\"tag_name\": \"$TAG\", \"ref\": \"$CI_COMMIT_SHA\"}" \
        "$CI_API_V4_URL/projects/$CI_PROJECT_ID/repository/tags"

Build and Upload Master:
  stage: Build and Upload
  image: alpine/helm:3.10.1
  rules:
    - if: $CI_COMMIT_TAG
      when: always
    - when: never
  script:
    - helm plugin install https://github.com/chartmuseum/helm-push
    - helm repo add --username gitlab-ci-token --password $CI_JOB_TOKEN gitlab-helm-repo "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/helm/stable"
    - helm cm-push ./ --version="${CI_COMMIT_TAG}" gitlab-helm-repo

Build and Upload Review:
  stage: Build and Upload
  image: alpine/helm:3.10.1
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: '$CI_COMMIT_BRANCH == "master"'
      when: never
    - if: '$CI_PIPELINE_SOURCE == "push" || $CI_PIPELINE_SOURCE == "web"'
    - when: never
  script:
    - helm plugin install https://github.com/chartmuseum/helm-push
    - helm repo add --username gitlab-ci-token --password $CI_JOB_TOKEN gitlab-helm-repo "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/helm/stable"
    - helm cm-push ./ --version="0.0.0-${CI_COMMIT_REF_SLUG}" gitlab-helm-repo